from ngsolve import *
from ngsolve.meshes import *
import numpy as np

mesh = MakeStructured3DMesh(nx=3, ny=3, nz=3)

Draw (mesh)

n = 22  # independent voxeldata mesh-size
data = np.zeros( (n, n, n) )
for i in range(n):
    for j in range(n):
        for k in range(n):
            px,py,pz = i/(n-1), j/(n-1), k/(n-1)
            data[i][j][k] = px*(1-px)*py*(1-py)*pz

cf = VoxelCoefficient( (0,0,0), (1,1,1), data, linear=True)

fes = H1(mesh, order=3)
gfu = GridFunction(fes)

gfu.Set (cf)

Draw (gfu)

print ("num vertices: ", mesh.nv)
print ("fespace dimension: ", fes.ndof)
